/* See LICENSE file for copyright and license details. */
#include <stdarg.h> /* va_start(3), va_end(3), va_list */
#include <stdio.h> /* fputc(3), perror(3) */
#include <stdlib.h> /* calloc(3), exit(3) */
#include <string.h> /* strlen(3) */

#include "util.h" /* die(3) */

void *
ecalloc(size_t nmemb, size_t size)
{
	void *p;

	if (!(p = calloc(nmemb, size)))
		die("calloc:");
	return p;
}

void
die(const char *fmt, ...) {
	va_list ap;

	va_start(ap, fmt);
	vfprintf(stderr, fmt, ap);
	va_end(ap);

	if (fmt[0] && fmt[strlen(fmt)-1] == ':') {
		fputc(' ', stderr);
		perror(NULL);
	} else {
		fputc('\n', stderr);
	}

	exit(1);
}
